import os
import re
from collections import defaultdict

def create_country_file():
    countries = set()

    data_dir = './books'
    source_files = os.listdir(data_dir)
    for file in source_files:
        for i, line in enumerate(open(os.path.join(data_dir, file), encoding='UTF-8')):
            try:
                writers = line[line.index('writer:')+len('writer:') : line.index('translator:')]
            except Exception as e:
                print(file, i, line)
                continue
            # print(file, i, writers)
            writers = writers.split('/')
            for writer in writers:
                writer = writer.strip()
                if len(writer) == 0 or writer[0] not in ['（', '(', '[', '【']:
                    continue
                right = -1
                if writer[0] == '（':
                    right = writer.find('）')
                elif writer[0] == '(':
                    right = writer.find(')')
                elif writer[0] == '[':
                    right = writer.find(']')
                else:
                    right = writer.find('】')
                if right != -1:
                    country = writer[1:right].strip()
                    if len(country) > 0:
                        countries.add(country)

    d = {}
    for country in countries:
        print(country, '->')
        full_name = input()
        if full_name.strip() == '':
            d[country] = country
            continue
        elif full_name == 'n':
            continue
        d[country] = full_name
    with open('./processed/countries.txt', 'w') as f:
        for k, v in d.items():
            f.write('{}\t{}\n'.format(k, v))

def get_writers():
    name_dict = {}
    with open('./processed/countries.txt') as f:
        for line in f:
            line = line.strip()
            name, full_name = line.strip().split('\t')
            name_dict[name] = full_name
    d = defaultdict(set)
    data_dir = './books'
    source_files = os.listdir(data_dir)
    for file in source_files:
        for i, line in enumerate(open(os.path.join(data_dir, file), encoding='UTF-8')):
            try:
                writers = line[line.index('writer:')+len('writer:') : line.index('translator:')]
            except Exception as e:
                print(file, i, line)
                continue
            writers = writers.split('/')
            for writer in writers:
                writer = writer.strip()
                if len(writer) == 0 or writer[0] not in ['（', '(', '[', '【']:
                    continue
                right = -1
                if writer[0] == '（':
                    right = writer.find('）')
                elif writer[0] == '(':
                    right = writer.find(')')
                elif writer[0] == '[':
                    right = writer.find(']')
                else:
                    right = writer.find('】')
                if right == -1:
                    print(file, i, line)
                    print(writer)
                    continue
                country = writer[1:right].strip()
                if country not in name_dict:
                    continue
                person = writer[right+1:].strip()
                search = re.search(r'(.*)\((.*)\)', person)
                if search is None:
                    d[name_dict[country]].add(person.replace(' ', ''))
                    # if person.encode( 'UTF-8' ).isalpha():
                    #     print(file, i, line)
                    #     print(person.replace(' ', ''))
                else:
                    # if search.group(1) != '' and search.group(1)[0].encode( 'UTF-8' ).isalpha():
                    #     print(file, i, line)
                    #     print(search.group(1).replace(' ', ''))
                    d[name_dict[country]].add(search.group(1).replace(' ', ''))
        with open('./processed/writers.txt', 'w') as f:
            for k, v in d.items():
                print(k, file=f)
                for p in v:
                    print(p, file=f)
                print('===============', file=f)


                    

if __name__ == '__main__':
    create_country_file()
    # get_writers()