import os

output_path = './dicts'
if not os.path.exists('./dicts'):
    os.mkdir(output_path)

ent_set = set()

# person nr
with open(os.path.join(output_path, 'person_dict.txt'), 'w') as f:
    for line in  open('./processed/person.txt'):
        _, cname, ename, _ = line.strip().split('\t')
        if cname != 'None':
            print(f'{cname} nr', file=f)
            ent_set.add(cname)
        if ename != 'None':
            print(f'{ename} nr', file=f)
            ent_set.add(ename)

# book nw
with open(os.path.join(output_path, 'book_dict.txt'), 'w') as f:
    for line in  open('./processed/books.txt'):
        title, _ = line.strip().split('\t')
        print(f'{title} nw', file=f)
        ent_set.add(title)

# press nt
with open(os.path.join(output_path, 'press_dict.txt'), 'w') as f:
    for line in  open('./processed/press.txt'):
       print(f'{line.strip()} nt', file=f)
       ent_set.add(line.strip())

# tag nz
with open(os.path.join(output_path, 'tags_dict.txt'), 'w') as f:
    for line in  open('./processed/tags.txt'):
        tag = line.strip()
        if tag not in ent_set:  # 防止覆盖之前的pos tag
            print(f'{tag} nz', file=f)

    
