## work_dir:
```
.
├── books # 原始数据
│   ├── android.txt
│   ├── linux.txt
│   ├── 爱情.txt
│   ...
│   └── 宗教.txt
├── dicts # 分词用的自定义词典
│   ├── book_dict.txt
│   ├── person_dict.txt
│   ├── press_dict.txt
│   └── tags_dict.txt
├── processed # 转换后的数据文件
│   ├── books.txt # 书籍标题
│   ├── countries.txt # 国家：缩写->全称
│   ├── ntriples.nt # 三元组文件
│   ├── person.txt # 作家+译者
│   ├── press.txt # 出版社
│   └── tags.txt # 书籍tag
├── build_ntriples.py # 数据处理
├── get_country.py # 建立国家全称
├── get_dict.py # 生成jieba词典
├── jena_sparql_endpoint.py # 向Fuseki发送SPARQL查询
├── log.txt  
├── qa_main.py # qa主文件
├── question2sparql.py # 自然语言问题转换为SPARQL查询
├── question_example.txt # 问题输入例子
├── question_temp.py # 问题匹配规则
├── readme.md
└── word_tagging.py # 分词
```
## 环境
apache-jena-3.17.0 + apache-jena-fuseki-3.17.0

## 准备数据
- 手动生成国家全名：`python get_country.py`
- 生成n_triples格式文件：`python build_ntiples.py`
- 生成jieba词典：`python get_dict.py`
- 将生成的./processed/ntriples.nt文件上传到fuseki服务器

## qa
based on https://github.com/SimmerChan/KG-demo-for-movie、http://www.openkg.cn/tool/refo-kbqa

Dependency：jieba, SPARQLWrapper, refo

> Note：jieba分词用户词典不支持自定义分词，需要在./site-packages/jieba/posseg/__init__.py中做如下改动：
```python
# re_han_internal = re.compile("([\u4E00-\u9FD5a-zA-Z0-9+#&\._]+)")
re_han_internal = re.compile("(.+)")
```
运行：`python qa_main.py`

**输入**：
```
周志明写过哪些书
```

**输出**：
```
==> 查询语句:

PREFIX : <http://kg.com/book/ontology/>
PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>

SELECT DISTINCT ?title WHERE {
?p :chineseName '周志明'.?b :title ?title .?b :writer ?p
}

==> 查询结果:
深入理解Java虚拟机（第3版）、深入理解Java虚拟机（第2版）、智慧的疆界

question: 周志明写过哪些书

```